<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPoint_2D ArrayType
 * @subpackage Arrays
 */
class ArrayOfPoint_2D extends AbstractStructArrayBase
{
    /**
     * The Point_2D
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Point_2D[]
     */
    public $Point_2D;
    /**
     * Constructor method for ArrayOfPoint_2D
     * @uses ArrayOfPoint_2D::setPoint_2D()
     * @param \StructType\Point_2D[] $point_2D
     */
    public function __construct(array $point_2D = array())
    {
        $this
            ->setPoint_2D($point_2D);
    }
    /**
     * Get pointD value
     * @return pointD
     */
    public function getPoint_2D()
    {
        return $this->Point_2D;
    }
    /**
     * This method is responsible for validating the values passed to the setPoint_2D method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPoint_2D method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePoint_2DForArrayConstraintsFromSetPoint_2D(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPoint_2DPoint_2DItem) {
            // validation for constraint: itemType
            if (!$arrayOfPoint_2DPoint_2DItem instanceof \StructType\Point_2D) {
                $invalidValues[] = is_object($arrayOfPoint_2DPoint_2DItem) ? get_class($arrayOfPoint_2DPoint_2DItem) : sprintf('%s(%s)', gettype($arrayOfPoint_2DPoint_2DItem), var_export($arrayOfPoint_2DPoint_2DItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Point_2D property can only contain items of type \StructType\Point_2D, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set pointD value
     * @param pointD $pointD
     * @return \ArrayType\ArrayOfPoint_2D
     */
    public function setPoint_2D(array $point_2D = array())
    {
        // validation for constraint: array
        if ('' !== ($point_2DArrayErrorMessage = self::validatePoint_2DForArrayConstraintsFromSetPoint_2D($point_2D))) {
            throw new \InvalidArgumentException($point_2DArrayErrorMessage, __LINE__);
        }
        $this->Point_2D = $point_2D;
        return $this;
    }
    /**
     * Add item to Point_2D value
     * @throws \InvalidArgumentException
     * @param \StructType\Point_2D $item
     * @return \ArrayType\ArrayOfPoint_2D
     */
    public function addToPoint_2D(\StructType\Point_2D $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Point_2D) {
            throw new \InvalidArgumentException(sprintf('The Point_2D property can only contain items of type \StructType\Point_2D, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Point_2D[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Point_2D|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Point_2D|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Point_2D|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Point_2D|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Point_2D|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Point_2D
     */
    public function getAttributeName()
    {
        return 'Point_2D';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPoint_2D
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
